﻿Omniscience = LibStub("AceAddon-3.0"):NewAddon("Omniscience", "AceEvent-3.0", "LibBars-1.0")
local bars = LibStub("LibBars-1.0")
local media = LibStub("LibSharedMedia-3.0")
local bitband = bit.band

local defaults = {
  profile = {
    texture = "Ruben",
    playeronly = true,
    groups = { 
      cooldown_friendly = {name = "Group Cooldowns",   srcflags = 7,   dstflags = nil, enabled = true, position = { x = 300, y = 100}},
      cooldown_hostile =  {name = "Hostile Cooldowns", srcflags = 8,   dstflags = nil, enabled = true, position = { x = 300, y = 150}},
      cast_hostile =      {name = "Hostile Casts",     srcflags = 8,   dstflags = nil, enabled = true, position = { x = 300, y = 200}},
      buff_hostile =      {name = "Hostile Buffs",     srcflags = 8,   dstflags = nil, enabled = true, position = { x = 300, y = 250}},
      crowd_control =     {name = "Crowd Control",     srcflags = nil, dstflags = 8,   enabled = true, position = { x = 300, y = 300}},
      },
    spells = {
      ["SPELL_CAST_START"] = {
        [GetSpellInfo(26994)] = {time = 1200, group = "cooldown_friendly", srcflags = 7, dstflags = nil}, -- Rebirth 
        [GetSpellInfo(27239)] = {time = 3600, group = "cooldown_friendly", srcflags = 7, dstflags = nil}, -- Soulstone Resurrection
        [GetSpellInfo(20549)] = {time = 0.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- War Stomp
        [GetSpellInfo(116)] =   {time = 2.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Frostbolt
        [GetSpellInfo(133)] =   {time = 3,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Fireball
        [GetSpellInfo(2120)] = 	{time = 3,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Flamestrike
        [GetSpellInfo(66)] =    {time = 8,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Invisibility
        [GetSpellInfo(118)] =   {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Polymorph
        [GetSpellInfo(28272)] = {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Polymorph: Pig
        [GetSpellInfo(28271)] = {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Polymorph: Turtle
        [GetSpellInfo(11366)] = {time = 6,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Pyroblast
        [GetSpellInfo(2948)] =  {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Scorch
        [GetSpellInfo(31707)] = {time = 2.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Waterbolt
        [GetSpellInfo(31935)] = {time = 1,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Avenger's Shield
        [GetSpellInfo(635)] =   {time = 2.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Holy Light
        [GetSpellInfo(19750)] = {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Flash of Light
        [GetSpellInfo(24275)] = {time = 1,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Hammer of Wrath
        [GetSpellInfo(2812)] =  {time = 2,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Holy Wrath
        [GetSpellInfo(2878)] =  {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Turn Undead
        [GetSpellInfo(10326)] = {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Turn Evil
        [GetSpellInfo(686)] =   {time = 2.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Shadow Bolt
        [GetSpellInfo(348)] =   {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Immolate
        [GetSpellInfo(6353)] =  {time = 4,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Soul Fire
        [GetSpellInfo(5676)] =  {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Searing Pain
        [GetSpellInfo(5782)] =  {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Fear
        [GetSpellInfo(5484)] =  {time = 2,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Howl of Terror
        [GetSpellInfo(710)] =   {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Banish
        [GetSpellInfo(1098)] =  {time = 3,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Enslave Demon
        [GetSpellInfo(1122)] =  {time = 2,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Inferno
        [GetSpellInfo(27243)] = {time = 2,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Seed of Corruption
        [GetSpellInfo(29722)] = {time = 2.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Incinerate
        [GetSpellInfo(30108)] = {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Unstable Affliction
        [GetSpellInfo(30283)] = {time = 0.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Shadowfury
        [GetSpellInfo(6358)] =  {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Seduction
        [GetSpellInfo(32546)] = {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Binding Heal
        [GetSpellInfo(2060)] =  {time = 2.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Greater Heal
        [GetSpellInfo(2061)] =  {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Flash Heal
        [GetSpellInfo(2054)] =  {time = 2.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Heal
        [GetSpellInfo(14914)] = {time = 3,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Holy Fire
        [GetSpellInfo(32375)] = {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Mass Dispel
        [GetSpellInfo(8092)] =  {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Mind Blast
        [GetSpellInfo(605)] =   {time = 3,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Mind Control
        [GetSpellInfo(8129)] =  {time = 3,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Mana Burn
        [GetSpellInfo(453)] =   {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Mind Soothe
        [GetSpellInfo(596)] =   {time = 3,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Prayer of Healing
        [GetSpellInfo(585)] =   {time = 2,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Smite
        [GetSpellInfo(9484)] =  {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Shackle Undead
        [GetSpellInfo(34914)] = {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Vampiric Touch
        [GetSpellInfo(1842)] =  {time = 2,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Disarm Trap
        [GetSpellInfo(19434)] = {time = 3,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Aimed Shot
        [GetSpellInfo(1513)] =  {time = 1,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Scare Beast
        [GetSpellInfo(1510)] =  {time = 6,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Volley
        [GetSpellInfo(2641)] =  {time = 5,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Dismiss Pet
        [GetSpellInfo(1002)] =  {time = 2,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Eyes of the Beast
        [GetSpellInfo(34120)] = {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Steady Shot
        [GetSpellInfo(33786)] = {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Cyclone
        [GetSpellInfo(5185)] =  {time = 3,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Healing Touch
        [GetSpellInfo(8936)] =  {time = 2,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Regrowth
        [GetSpellInfo(20484)] = {time = 2,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Rebirth
        [GetSpellInfo(2912)] =  {time = 3.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Starfire
        [GetSpellInfo(5176)] =  {time = 2,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Wrath
        [GetSpellInfo(339)] =   {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Entangling Roots
        [GetSpellInfo(2637)] =  {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Hibernate
        [GetSpellInfo(2908)] =  {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Soothe Animal
        [GetSpellInfo(740)] =   {time = 10,  group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Tranquility
        [GetSpellInfo(16914)] = {time = 10,  group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Hurricane
        [GetSpellInfo(8004)] =  {time = 1.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Lesser Healing Wave
        [GetSpellInfo(331)] =   {time = 2.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Healing Wave
        [GetSpellInfo(421)] =   {time = 2.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Chain Lightning
        [GetSpellInfo(1064)] =  {time = 2.5, group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Chain Heal
        [GetSpellInfo(403)] =   {time = 3,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Lightning Bolt
        [GetSpellInfo(6196)] =  {time = 2,   group = "cast_hostile", srcflags = 8, dstflags = nil}, -- Far Sight
      },
      ["SPELL_CAST_SUCCESS"] = {
        [28610] =               {time = 30,   group = "cooldown_friendly", srcflags = 1, dstflags = nil}, -- shadow ward, for testing
        [GetSpellInfo(27154)] = {time = 3600, group = "cooldown_friendly", srcflags = 7, dstflags = nil}, -- Lay on Hands
        [GetSpellInfo(19752)] = {time = 3600, group = "cooldown_friendly", srcflags = 7, dstflags = nil}, -- Divine Intervention
        [GetSpellInfo(32182)] = {time = 600,  group = "cooldown_friendly", srcflags = 7, dstflags = nil}, -- Heroism
        [GetSpellInfo(2825)] =  {time = 600,  group = "cooldown_friendly", srcflags = 7, dstflags = nil}, -- Bloodlust
        [GetSpellInfo(20589)] = {time = 60,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Escape Artist
        [GetSpellInfo(20554)] = {time = 120, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Berserking
        [GetSpellInfo(20594)] = {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Stoneform
        [GetSpellInfo(7744)] =  {time = 120, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Will of the Forsaken
        [GetSpellInfo(20549)] = {time = 120, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- War Stomp
        [GetSpellInfo(746)] =   {time = 60,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- First Aid
        [GetSpellInfo(5211)] =  {time = 300, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Bash
        [GetSpellInfo(1850)] =  {time = 300, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Dash
        [GetSpellInfo(16979)] = {time = 15,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Feral Charge
        [GetSpellInfo(22842)] = {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Frenzied Regeneration
        [GetSpellInfo(33831)] = {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Force of Nature
        [GetSpellInfo(16914)] = {time = 60,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Hurricane
        [GetSpellInfo(22570)] = {time = 10,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Maim
        [GetSpellInfo(16689)] = {time = 60,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Nature's Grasp
        [GetSpellInfo(17116)] = {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Nature's Swiftness
        [GetSpellInfo(18562)] = {time = 15,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Swiftmend
        [GetSpellInfo(740)] =   {time = 300, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Tranquility
        [GetSpellInfo(19434)] = {time = 6,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Aimed Shot
        [GetSpellInfo(3044)] =  {time = 6,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Arcane Shot
        [GetSpellInfo(19306)] = {time = 5,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Counterattack
        [GetSpellInfo(34477)] = {time = 120, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Misdirection
        [GetSpellInfo(1495)] =  {time = 5,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Mongoose Bite
        [GetSpellInfo(2643)] =  {time = 10,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Multi-Shot
        [GetSpellInfo(34026)] = {time = 5,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Kill Command
        [GetSpellInfo(2973)] =  {time = 6,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Raptor Strike
        [GetSpellInfo(19574)] = {time = 120, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Bestial Wrath
        [GetSpellInfo(5116)] =  {time = 12,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Concussive Shot
        [GetSpellInfo(19263)] = {time = 300, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Deterrence
        [GetSpellInfo(5384)] =  {time = 30,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Feign Death
        [GetSpellInfo(1499)] =  {time = 30,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Freezing Trap
        [GetSpellInfo(13809)] = {time = 30,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Frost Trap
        [GetSpellInfo(13795)] = {time = 30,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Immolation Trap
        [GetSpellInfo(19577)] = {time = 60,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Intimidation
        [GetSpellInfo(3045)] =  {time = 300, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Rapid Fire
        [GetSpellInfo(23989)] = {time = 300, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Readiness
        [GetSpellInfo(19503)] = {time = 30,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Scatter Shot
        [GetSpellInfo(34490)] = {time = 20,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Silencing Shot
        [GetSpellInfo(34600)] = {time = 30,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Snake Trap
        [GetSpellInfo(1510)] =  {time = 60,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Volley
        [GetSpellInfo(19386)] = {time = 120, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Wyvern Sting
        [GetSpellInfo(12042)] = {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Arcane Power
        [GetSpellInfo(11113)] = {time = 45,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Blast Wave
        [GetSpellInfo(11129)] = {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Combustion
        [GetSpellInfo(120)] =   {time = 10,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Cone of Cold
        [GetSpellInfo(2139)] =  {time = 24,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Counterspell
        [GetSpellInfo(31661)] = {time = 20,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Dragon's Breath
        [GetSpellInfo(12043)] = {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Presence of Mind
        [GetSpellInfo(1953)] =  {time = 15,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Blink
        [GetSpellInfo(2136)] =  {time = 6.5, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Fire Blast
        [GetSpellInfo(543)] =   {time = 30,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Fire Ward
        [GetSpellInfo(6143)] =  {time = 30,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Frost Ward
        [GetSpellInfo(122)] =   {time = 21,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Frost Nova
        [GetSpellInfo(11426)] = {time = 30,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Ice Barrier
        [GetSpellInfo(45438)] = {time = 300, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Ice Block
        [GetSpellInfo(31687)] = {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Summon Water Elemental
        [GetSpellInfo(31935)] = {time = 30,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Avenger's Shield
        [GetSpellInfo(31884)] = {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Avenging Wrath
        [GetSpellInfo(1044)] =  {time = 25,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Blessing of Freedom
        [GetSpellInfo(1022)] =  {time = 300, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Blessing of Protection
        [GetSpellInfo(26573)] = {time = 8,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Consecration
        [GetSpellInfo(35395)] = {time = 10,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Crusader Strike
        [GetSpellInfo(31842)] = {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Divine Illumination
        [GetSpellInfo(20216)] = {time = 120, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Divine Favor
        [GetSpellInfo(498)] =   {time = 300, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Divine Protection
        [GetSpellInfo(642)] =   {time = 300, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Divine Shield
        [GetSpellInfo(853)] =   {time = 60,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Hammer of Justice
        [GetSpellInfo(24275)] = {time = 6,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Hammer of Wrath
        [GetSpellInfo(20925)] = {time = 10,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Holy Shield
        [GetSpellInfo(20473)] = {time = 15,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Holy Shock
        [GetSpellInfo(20271)] = {time = 10,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Judgement
        [GetSpellInfo(20066)] = {time = 60,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Repentance
        [GetSpellInfo(2944)] =  {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Devouring Plague
        [GetSpellInfo(2651)] =  {time = 300, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Elune's Grace
        [GetSpellInfo(6346)] =  {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Fear Ward
        [GetSpellInfo(14751)] = {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Inner Focus
        [GetSpellInfo(8092)] =  {time = 5.5, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Mind Blast
        [GetSpellInfo(33206)] = {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Pain Suppression
        [GetSpellInfo(8122)] =  {time = 26,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Psychic Scream
        [GetSpellInfo(10060)] = {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Power Infusion
        [GetSpellInfo(17)] =    {time = 15,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Power Word: Shield
        [GetSpellInfo(33076)] = {time = 10,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Prayer of Mending
        [GetSpellInfo(32379)] = {time = 6,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Shadow Word: Death
        [GetSpellInfo(34433)] = {time = 300, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Shadowfiend
        [GetSpellInfo(15487)] = {time = 45,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Silence
        [GetSpellInfo(32676)] = {time = 120, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Consume Magic
        [GetSpellInfo(15286)] = {time = 10,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Vampiric Embrace
        [GetSpellInfo(13750)] = {time = 300, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Adrenaline Rush
        [GetSpellInfo(13877)] = {time = 120, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Blade Flurry
        [GetSpellInfo(2094)] =  {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Blind
        [GetSpellInfo(14177)] = {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Cold Blood
        [GetSpellInfo(45182)] = {time = 60,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Cheating Death
        [GetSpellInfo(31224)] = {time = 60,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Cloak of Shadows
        [GetSpellInfo(5277)] =  {time = 300, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Evasion
        [GetSpellInfo(14278)] = {time = 20,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Ghostly Strike
        [GetSpellInfo(1776)] =  {time = 10,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Gouge
        [GetSpellInfo(1766)] =  {time = 10,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Kick
        [GetSpellInfo(408)] =   {time = 20,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Kidney Shot
        [GetSpellInfo(8643)] =  {time = 20,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Kidney Shot
        [GetSpellInfo(14183)] = {time = 120, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Premeditation
        [GetSpellInfo(14251)] = {time = 6,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Riposte
        [GetSpellInfo(2983)] =  {time = 300, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Sprint
        [GetSpellInfo(1856)] =  {time = 300, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Vanish
        [GetSpellInfo(421)] =   {time = 6,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Chain Lightning
        [GetSpellInfo(8042)] =  {time = 5,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Earth Shock
        [GetSpellInfo(16166)] = {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Elemental Mastery
        [GetSpellInfo(1535)] =  {time = 15,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Fire Nova Totem
        [GetSpellInfo(8050)] =  {time = 5,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Flame Shock
        [GetSpellInfo(8056)] =  {time = 5,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Frost Shock
        [GetSpellInfo(8177)] =  {time = 15,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Grounding Totem
        [GetSpellInfo(16188)] = {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Nature's Swiftness
        [GetSpellInfo(17364)] = {time = 20,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Stormstrike
        [GetSpellInfo(30823)] = {time = 120, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Shamanistic Rage
        [GetSpellInfo(18288)] = {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Amplify Curse
        [GetSpellInfo(34936)] = {time = 8,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Backlash
        [GetSpellInfo(17962)] = {time = 10,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Conflagrate
        [GetSpellInfo(6789)] =  {time = 120, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Death Coil
        [GetSpellInfo(19505)] = {time = 8,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Devour Magic
        [GetSpellInfo(5484)] =  {time = 40,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Howl of Terror
        [GetSpellInfo(17877)] = {time = 15,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Shadowburn
        [GetSpellInfo(6229)] =  {time = 30,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Shadow Ward
        [GetSpellInfo(6360)] =  {time = 4,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Soothing Kiss
        [GetSpellInfo(6353)] =  {time = 60,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Soul Fire
        [GetSpellInfo(19244)] = {time = 24,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Spell Lock
        [GetSpellInfo(30283)] = {time = 20,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Shadowfury
        [GetSpellInfo(18499)] = {time = 30,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Berserker Rage
        [GetSpellInfo(2687)] =  {time = 30,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Bloodrage
        [GetSpellInfo(23881)] = {time = 6,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Bloodthirst
        [GetSpellInfo(12809)] = {time = 45,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Concussion Blow
        [GetSpellInfo(12292)] = {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Death Wish
        [GetSpellInfo(20252)] = {time = 20,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Intercept
        [GetSpellInfo(5246)] =  {time = 180, group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Intimidating Shout
        [GetSpellInfo(12294)] = {time = 6,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Mortal Strike
        [GetSpellInfo(7384)] =  {time = 5,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Overpower
        [GetSpellInfo(6552)] =  {time = 10,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Pummel
        [GetSpellInfo(72)] =    {time = 12,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Shield Bash
        [GetSpellInfo(23922)] = {time = 6,   group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Shield Slam
        [GetSpellInfo(12328)] = {time = 30,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Sweeping Strikes
        [GetSpellInfo(1680)] =  {time = 10,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Whirlwind
        [GetSpellInfo(23920)] = {time = 10,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Spell Reflection
        [GetSpellInfo(3411)] =  {time = 30,  group = "cooldown_hostile", srcflags = 8, dstflags = nil}, -- Intervene
      },
      ["SPELL_AURA_APPLIED"] = {
        [339] =   {time = 12, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Entangling Roots 1
        [1062] =  {time = 15, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Entangling Roots 2
        [5195] =  {time = 18, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Entangling Roots 3
        [5196] =  {time = 21, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Entangling Roots 4
        [9852] =  {time = 24, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Entangling Roots 5
        [9853] =  {time = 27, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Entangling Roots 6
        [26989] = {time = 27, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Entangling Roots 7
        [2637] =  {time = 20, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Hibernate 1
        [18657] = {time = 30, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Hibernate 2
        [18658] = {time = 40, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Hibernate 3
        [33786] = {time = 6,  group = "crowd_control", srcflags = nil, dstflags = 8}, -- Cyclone
        [19386] = {time = 12, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Wyvern Sting 1
        [24132] = {time = 12, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Wyvern Sting 2
        [24133] = {time = 12, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Wyvern Sting 3
        [27068] = {time = 12, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Wyvern Sting 4
        [1513] =  {time = 10, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Scare Beast 1
        [14326] = {time = 10, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Scare Beast 2
        [14327] = {time = 10, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Scare Beast 3
        [118] =   {time = 30, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Polymorph 1
        [12824] = {time = 30, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Polymorph 2
        [12825] = {time = 30, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Polymorph 3
        [12826] = {time = 30, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Polymorph 4
        [28272] = {time = 30, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Polymorph Pig
        [28271] = {time = 30, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Polymorph Turtle
        [25464] = {time = 8,  group = "crowd_control", srcflags = nil, dstflags = 8}, -- Frost Shock 5
        [853] =   {time = 3,  group = "crowd_control", srcflags = nil, dstflags = 8}, -- Hammmer of Justice 1
        [5588] =  {time = 4,  group = "crowd_control", srcflags = nil, dstflags = 8}, -- Hammmer of Justice 2
        [5589] =  {time = 5,  group = "crowd_control", srcflags = nil, dstflags = 8}, -- Hammmer of Justice 3
        [10308] = {time = 6,  group = "crowd_control", srcflags = nil, dstflags = 8}, -- Hammmer of Justice 4
        [20066] = {time = 6,  group = "crowd_control", srcflags = nil, dstflags = 8}, -- Repentance
        [5627] =  {time = 15, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Turn Undead 2
        [10326] = {time = 20, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Turn Evil
        [10912] = {time = 60, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Mind Control 3
        [9484] =  {time = 30, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Shackle Undead 1
        [9485] =  {time = 40, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Shackle Undead 2
        [10955] = {time = 50, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Shackle Undead 3
        [6770] =  {time = 25, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Sap 1
        [2070] =  {time = 35, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Sap 2
        [11297] = {time = 45, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Sap 3
        [2094] =  {time = 10, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Blind
        [5782] =  {time = 10, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Fear 1
        [6213] =  {time = 15, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Fear 1
        [6215] =  {time = 20, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Fear 1
        [6358] =  {time = 15, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Seduction
        [5484] =  {time = 6,  group = "crowd_control", srcflags = nil, dstflags = 8}, -- Howl of Terror 1
        [17928] = {time = 8,  group = "crowd_control", srcflags = nil, dstflags = 8}, -- Howl of Terror 2
        [710] =   {time = 20, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Banish 1
        [18647] = {time = 30, group = "crowd_control", srcflags = nil, dstflags = 8}, -- Banish 1
        [GetSpellInfo(26635)] = {time = 10,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Berserking
        [GetSpellInfo(7020)] =  {time = 8,   group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Stoneform
        [GetSpellInfo(7744)] =  {time = 5,   group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Will of the Forsaken
        [GetSpellInfo(20600)] = {time = 20,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Perception
        [GetSpellInfo(31641)] = {time = 8,   group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Blazing Speed
        [GetSpellInfo(45438)] = {time = 10,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Ice Block
        [GetSpellInfo(66)] =    {time = 20,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Invisibility
        [GetSpellInfo(12051)] = {time = 8,   group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Evocation
        [GetSpellInfo(12042)] = {time = 15,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Arcane Power
        [GetSpellInfo(130)] =   {time = 30,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Slow Fall
        [GetSpellInfo(543)] =   {time = 30,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Fire Ward
        [GetSpellInfo(6143)] =  {time = 30,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Frost Ward
        [GetSpellInfo(12043)] = {time = 30,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Presence of Mind
        [GetSpellInfo(11426)] = {time = 60,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Ice Barrier
        [GetSpellInfo(31884)] = {time = 20,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Avenging Wrath
        [GetSpellInfo(31842)] = {time = 10,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Divine Illumination
        [GetSpellInfo(498)] =   {time = 8,   group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Divine Protection
        [GetSpellInfo(642)] =   {time = 12,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Divine Shield
        [GetSpellInfo(1022)] =  {time = 10,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Blessing of Protection
        [GetSpellInfo(1044)] =  {time = 16,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Blessing of Freedom
        [GetSpellInfo(6940)] =  {time = 30,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Blessing of Sacrifice
        [GetSpellInfo(20216)] = {time = 30,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Divine Favor
        [GetSpellInfo(20164)] = {time = 30,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Seal of Justice
        [GetSpellInfo(6229)] =  {time = 30,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Shadow Ward
        [GetSpellInfo(34936)] = {time = 8,   group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Backlash
        [GetSpellInfo(17)] =    {time = 30,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Power Word: Shield
        [GetSpellInfo(139)] =   {time = 15,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Renew
        [GetSpellInfo(13896)] = {time = 15,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Feedback
        [GetSpellInfo(14892)] = {time = 15,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Inspiration
        [GetSpellInfo(10060)] = {time = 15,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Power Infusion
        [GetSpellInfo(552)] =   {time = 20,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Abolish Disease
        [GetSpellInfo(2651)] =  {time = 15,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Elune's Grace
        [GetSpellInfo(6346)] =  {time = 180, group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Fear Ward
        [GetSpellInfo(14751)] = {time = 30,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Inner Focus
        [GetSpellInfo(33206)] = {time = 8,   group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Pain Suppression
        [GetSpellInfo(871)] =   {time = 10,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Shield Wall
        [GetSpellInfo(1719)] =  {time = 15,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Recklessness
        [GetSpellInfo(20230)] = {time = 15,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Retaliation
        [GetSpellInfo(18499)] = {time = 10,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Berserker Rage
        [GetSpellInfo(12975)] = {time = 20,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Last Stand
        [GetSpellInfo(12292)] = {time = 30,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Death Wish
        [GetSpellInfo(12328)] = {time = 30,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Sweeping Strikes
        [GetSpellInfo(469)] =   {time = 120, group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Commanding Shout
        [GetSpellInfo(23920)] = {time = 5,   group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Spell Reflection
        [GetSpellInfo(2983)] =  {time = 15,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Sprint
        [GetSpellInfo(5277)] =  {time = 15,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Evasion
        [GetSpellInfo(13877)] = {time = 15,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Blade Flurry
        [GetSpellInfo(13750)] = {time = 15,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Adrenaline Rush
        [GetSpellInfo(14177)] = {time = 30,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Cold Blood
        [GetSpellInfo(14278)] = {time = 7,   group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Ghostly Strike
        [GetSpellInfo(31224)] = {time = 5,   group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Cloak of Shadows
        [GetSpellInfo(45182)] = {time = 3,   group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Cheating Death
        [GetSpellInfo(3045)] =  {time = 15,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Rapid Fire
        [GetSpellInfo(19263)] = {time = 10,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Deterrence
        [GetSpellInfo(19574)] = {time = 18,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Bestial Wrath
        [GetSpellInfo(34692)] = {time = 18,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- The Beast Within
        [GetSpellInfo(1850)] =  {time = 15,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Dash
        [GetSpellInfo(22812)] = {time = 15,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Barkskin
        [GetSpellInfo(29166)] = {time = 20,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Innervate
        [GetSpellInfo(5217)] =  {time = 6,   group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Tiger's Fury
        [GetSpellInfo(22842)] = {time = 10,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Frenzied Regeneration
        [GetSpellInfo(33763)] = {time = 7,   group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Lifebloom
        [GetSpellInfo(774)] =   {time = 12,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Rejuvenation
        [GetSpellInfo(2893)] =  {time = 8,   group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Abolish Poison
        [GetSpellInfo(16689)] = {time = 45,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Nature's Grasp
        [GetSpellInfo(17116)] = {time = 30,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Nature's Swiftness
        [GetSpellInfo(16166)] = {time = 30,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Elemental Mastery
        [GetSpellInfo(2825)] =  {time = 40,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Bloodlust
        [GetSpellInfo(32182)] = {time = 40,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Heroism
        [GetSpellInfo(30823)] = {time = 30,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Shamanistic Rage
        [GetSpellInfo(974)] =   {time = 120, group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Earth Shield
        [GetSpellInfo(30802)] = {time = 10,  group = "buff_hostile", srcflags = nil, dstflags = 8}, -- Unleashed Rage
      },
    },
  },
}

Omniscience.blacklist = {
	[33073] =	true, -- Holy Shock secondary cast
	[32175] = 	true, -- Stormstrike attack mechanic
	[32176] =	true, -- Stormstrike attack mechanic
	[30032] = 	true, -- Rampage secondary buff
}

function Omniscience:OnInitialize()
  self.db = LibStub("AceDB-3.0"):New("OmniscienceDB", defaults, "Default")
  for k in pairs(self.db.profile.groups) do
    local group = k
    self[group] = self:NewBarGroup(self.db.profile.groups[group].name, nil, 200, 12)
    self[group]:SetTexture(media:Fetch("statusbar", self.db.profile.texture))
    self[group].RegisterCallback(self, "AnchorClicked")
    self[group]:SetColorAt(0.00, 1, 0, 0, 1)
    self[group]:SetColorAt(0.33, 1, 1, 0, 1)
    self[group]:SetColorAt(0.66, 0, 1, 1, 1)
    self[group]:SetColorAt(1.00, 0, 0, 1, 1)
    self[group]:SetPoint("CENTER", UIParent, "CENTER", self.db.profile.groups[group].position.x, self.db.profile.groups[group].position.y)
    self[group]:SetScale(0.75)
  end
end

function Omniscience:UpdateMedia()
  for k in pairs(self.db.profile.groups) do
    self[k]:SetTexture(media:Fetch("statusbar", self.db.profile.texture))
  end
end

function Omniscience:OnEnable()
  self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
  media.RegisterCallback(self, "LibSharedMedia_Registered", "UpdateMedia")  
  media.RegisterCallback(self, "LibSharedMedia_SetGlobal", "UpdateMedia")  
  self:UpdateMedia()
end

function Omniscience:OnDisable()
  self:UnRegisterAllEvents()
  media.UnregisterCallback(self)
  for k in pairs(self.db.profile.groups) do
    self[group].UnregisterCallback(self)
  end
end

function Omniscience:AnchorClicked(callback, group, button)
  if button == "RightButton" then
    group:HideAnchor()
  end
end

function Omniscience:ToggleAnchors()
  for k in pairs(self.db.profile.groups) do
    self[k]:ToggleAnchor()
  end
end

function Omniscience:RunTest()
  for k in pairs(self.db.profile.groups) do
    local group = k
    self[group]:NewTimerBar("test-"..group, "Test", 30)
  end
end

function Omniscience:CheckAffiliation(flags, match)
  local result = (bitband(flags, match) ~= 0)
  return result or nil
end

--SPELL_AURA_APPLIED,0x0000000000000000,nil,0x80000000,0xF73000567F01250F,"Gordunni Back-Breaker",0xa48,12826,"Polymorph",0x40,DEBUFF
function Omniscience:COMBAT_LOG_EVENT_UNFILTERED(event, timestamp, eventType, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellID, spellName)
  if not self.db.profile.spells[eventType] then return end
  local spell = nil
  if self.db.profile.spells[eventType][spellName] then spell = spellName end
  if self.db.profile.spells[eventType][spellID] then spell = spellID end
  if not spell then return end
  if self.blacklist[spell] then return end
  local actor, flags, match = nil, nil, nil
  if self.db.profile.spells[eventType][spell].srcflags then
    flags, match = srcFlags, self.db.profile.spells[eventType][spell].srcflags
    actor = srcName
  elseif self.db.profile.spells[eventType][spell].dstflags then
    flags, match = dstFlags, self.db.profile.spells[eventType][spell].dstflags
    actor = dstName
  end
  if flags and match and not self:CheckAffiliation(flags, match) then return end
  local name = "Omniscience-"..srcGUID.."-"..spellID
  local value = self.db.profile.spells[eventType][spell].time
  local text = actor..": "..spellName
  local icon = select(3, GetSpellInfo(spellID))
  local group = self.db.profile.spells[eventType][spell].group
  self[group]:NewTimerBar(name, text, value, nil, icon)
end
